
Core - Bug # 53898

Status: Resolved Priority: Should have
Author: Bernhard Kraft Category: Code Cleanup
Created: 2013-11-23 Assigned To:
Updated: 2015-03-01 Due date:
TYPO3 Version: 6.2
PHP Version: 5.3
Complexity:
Is Regression: No
Sprint Focus: On Location Sprint
Subject: Unused code in PageLayoutView (~100 lines)
Description

There is an "if" statement [1] which can never be true. The "!" operator binds stronger than "===" which results in the left part of the
evaluation to be either TRUE or FALSE - but never "4".

Because of this the linked code block: [2] will never get executed (~100 lines)

In fact this block/piece of code isn't even working properly. Nowadays only the grid is used for PageLayout and as it is know the
configuration "mod.SHARED.colPos_list" is not available anymore. So the variable "$this->colPosList" always gets set from the
current backend layout [3]. Additionally I couldn't find a place where "$this->MOD_SETTINGS['function']" ever gets set to "4". As
mentioned: Grid view is used by default.

Testing: Create a backend layout with only one column and assign it to a page. Change the above mentioned if statement to:

if (TRUE || count($colList) === 1 && !$this->MOD_SETTINGS['function'] === 4) {

Now open the page with the page module: You are now looking at an ancient view of the TYPO3 page module which you probably
haven't seen for years.

Solution: Remove the mentioned if statement and code block (around 100 lines)

[1]
source:typo3/sysext/backend/Classes/Controller/PageLayoutController.php@51e23edaf7d518e05293874ac4b631db77594da9#L907

[2] source:typo3/sysext/backend/Classes/View/PageLayoutView.php@51e23edaf7d518e05293874ac4b631db77594da9#L649

[3]
source:typo3/sysext/backend/Classes/Controller/PageLayoutController.php@51e23edaf7d518e05293874ac4b631db77594da9#L529

Related issues:
related to Core - Bug # 39967: mod.SHARED.colPos_list is not taken into accou... Resolved 2012-08-19

Associated revisions
Revision 1e6df9d0 - 2015-03-01 20:45 - Jan Helke

[TASK] Remove unused code in PageLayoutView.php

Changing the backend view to use grid elements caused an ancient
piece of code in PageLayoutView.php to be never executed. In fact
an if statement in PageLayoutController.php always evaluates to
"FALSE" which lets the code in PageLayoutView.php never get
executed.

Change-Id: I4f97690b54efeb7659f86f1ef15fa8603e97f69b
Resolves: #53898
Releases: master
Reviewed-on: http://review.typo3.org/25662
Reviewed-by: Jo Hasenau <info@cybercraft.de>
Reviewed-by: Oliver Klee <typo3-coding@oliverklee.de>
Reviewed-by: Frederic Gaus <frederic.gaus@flagbit.de>
Tested-by: Benjamin Mack <benni@typo3.org>
Reviewed-by: Benjamin Mack <benni@typo3.org>
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

History
#1 - 2013-11-23 13:41 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25662

#2 - 2014-01-17 00:15 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25662

#3 - 2014-01-17 00:24 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25662

#4 - 2014-01-17 00:30 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25662

#5 - 2014-01-17 00:31 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25662

#6 - 2014-01-17 15:06 - Jo Hasenau

Actually colPosList should still be available, although it is not, due to a regression linked in #39967.
So before removing this piece of code, I would like to discuss that further.

#7 - 2014-02-26 22:33 - Markus Klein

@Jo:

Bernhard Kraft wrote about this patch on gerrit:

I am not really sure but if I remember it correctly the issue you linked to has nothing to do with this one.
This one is about the "single column view" which is not available since 4.? ... It is an ancient feature of TYPO 3.x
The "function" menu can not even get set to "4" as this option is removed. Let's wait for the result of the discussion you linke to - then take further
steps.

#8 - 2014-09-23 16:29 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25662

#9 - 2014-12-23 19:55 - Mathias Schreiber
- Target version changed from next-patchlevel to 7.1 (Cleanup)

#10 - 2015-01-26 14:59 - Anja Leichsenring
- Sprint Focus set to On Location Sprint

#11 - 2015-01-30 19:05 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25662

#12 - 2015-02-01 13:05 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/25662

#13 - 2015-03-01 21:00 - Jan Helke
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:1e6df9d0a0c158ac2e686cce76144eb5bd9c9405.

2015-08-04 3/3

http://review.typo3.org/25662
http://review.typo3.org/25662
http://review.typo3.org/25662

